/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.davic.resources;

/**
 * The resource server interface is implemented by objects which manage low 
 * level scarce resources and inform applications of changes in their status 
 * which may have happened due to factors beyond the control of the application.
 *
 * Any application wishing to use a resource controlled by an object 
 * implementing the ResourceServer interface must request access to that 
 * resource via an object implementing the ResourceProxy interface, and should 
 * release the resource via the same object when exclusive access to the 
 * resource is no longer needed.
 *
 */

public interface ResourceServer
{
  /**
   * This method informs a resource server that a particular object should be 
   * informed of changes in the state of the resources managed by that server.
   *
   * @param listener the object to be informed of state changes
   */

   public abstract void addResourceStatusEventListener (ResourceStatusListener listener);

  /**
   * This method informs a resource server that a particular object is no 
   * longer interested in being informed about changes in state of resources 
   * managed by that server. If the object had not registered it's interest 
   * initially then this method has no effect.
   *
   * @param listener the object which is no longer interested
   * 
   */

  public void removeResourceStatusEventListener(ResourceStatusListener listener);
}






