/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.event ;



/**

 * This class defines a repository which initially contains all the user events which can be 

 * delivered to an application. This includes all keycodes for which KEY_PRESSED and 

 * KEY_RELEASED events can be generated and all keychars for which KEY_TYPED events can be 

 * generated. Note that the set of keycodes and keychars which can be generated is dependent 

 * on the input devices of the MHP terminal. For example, this pre-defined repository

 * could be used by an application, which requires a pin code from the user,

 * in order to prevent another applications from receiving events. 

 *

 * @see UserEvent

 * @see org.havi.ui.event.HKeyCapabilities

 */

public class OverallRepository extends UserEventRepository {

	/**

	 * The constructor for the repository. The name of the constructed instance 

	 * (as returned by getName()) is implementation dependent.

	 */

    public OverallRepository () {super(null); }

	/**

	 * The constructor for the repository with a name.

	 * @param name the name to use for the repository

	 */

    public OverallRepository (String name) {super(name); }

}


