/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.event;

/**
 * This event is sent to the resource status event listeners when user input 
 * events which had been exclusively reserved by an application are no longer
 * exclusively reserved. Where one change in user input event reservation
 * results in instances of this event being sent to several applications, the
 * following shall apply.<p><ul>
 * <li>Each application shall receive its own instance of the <code>UserEventRepository</code>
 * object which forms the source to this event. Any changes made to that repository by
 * any one application shall not impact the instance seen by any other application.
 * <li>Any application receiving an instance of this event is allowed to attempt
 * to exclusively reserve some of the newly available user events. In this situation,
 * the normal resource management policy of the platform as described elsewhere in
 * the present document shall be obeyed.
 * <li>Any applications which have registered for shared access to any of these user
 * events shall start receiving those events following receipt of this event.
 * </ul>
 * @since MHP 1.0.2
 */

public class UserEventAvailableEvent extends org.davic.resources.ResourceStatusEvent {
        /**
         * Constructor for the event.
         *
         * @param source a <code>UserEventRepository</code> which contains the events
         * which stopped being exclusively reserved.
         * @since MHP 1.0.2
         */
        public UserEventAvailableEvent( Object source ) { super(source); }

        /**
         * Returns a <code>UserEventRepository</code> which contains the events which
         * were formerly exclusively reserved as passed into the constructor of the instance.
         *
         * @return a  <code>UserEventRepository</code>
         * @since MHP 1.0.2
         */
        public Object getSource(){return null;}
}


