/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.event;



/**

 * This event is sent to the resource status event listeners when user input 

 * events are exclusively reserved by an application.

 * <p>Each application shall receive its own instance of the <code>UserEventRepository</code>

 * object which forms the source to this event. Any changes made to that repository by

 * any one application shall not impact the instance seen by any other application.<p>

 * Any applications which have registered for shared access to any of these user

 * events shall stop receiving those user events following receipt of this event. If such

 * user events become available again, a <code>UserEventAvailableEvent</code> shall be

 * generated by the platform before any more of those user events are received by

 * applications.

 * @since MHP 1.0.2

 */



public class UserEventUnavailableEvent extends org.davic.resources.ResourceStatusEvent {

        /**

         * Constructor for the event.

         *

         * @param source a <code>UserEventRepository</code> which contains the events

         * which were exclusively reserved.

  	 * @since MHP 1.0.2

         */

        public UserEventUnavailableEvent( Object source ) { super(source); }



        /**

         * Returns a <code>UserEventRepository</code> which contains the events which

         * were exclusively reserved as passed into the constructor of the instance.

         *

         * @return a  <code>UserEventRepository</code>

  	 * @since MHP 1.0.2

         */

        public Object getSource(){return null;}

}


