/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.lang;

import java.net.URL;

/**
 * This class loader is used to load classes and resources from
 * a search path of URLs referring to locations where Java
 * class files may be stored. <p>
 * 
 * The classes that are loaded are by default only allowed to load
 * code through the parent classloader, or from the URLs specified
 * when the DVBClassLoader was created.
 */


public abstract class DVBClassLoader extends java.security.SecureClassLoader {

    /**
     * Constructs a new DVBClassLoader for the given URLs. The
     * URLs will be searched in the order specified for classes
     * and resources. 
     * <p>
     * If there is a security manager, this method first calls the
     * security manager's <code>checkCreateClassLoader</code>
     * method to ensure creation of a class loader is allowed.
     *
     * @param urls the URLs from which to load classes and resources
     * @throws SecurityException if a security manager exists and its
     *                  <code>checkCreateClassLoader</code> method
     *                  does not allow creation of a class loader.
     * @see  SecurityManager#checkCreateClassLoader
     */
    public DVBClassLoader(URL[] urls){ }

    /**
     * Constructs a new DVBClassLoader for the given URLs. The
     * URLs will be searched in the order specified for classes
     * and resources.
     * <p>
     * If there is a security manager, this method first calls the
     * security manager's <code>checkCreateClassLoader</code>
     * method to ensure creation of a class loader is allowed.
     *
     * @param urls the URLs from which to load classes and resources
     * @param parent the parent classloader for delegation
     * @throws SecurityException if a security manager exists and its
     *                  <code>checkCreateClassLoader</code> method
     *                  does not allow creation of a class loader.
     * @see  SecurityManager#checkCreateClassLoader
     */
    public DVBClassLoader(URL[] urls, ClassLoader parent){ 
    }

    /**
     * Finds and loads the class with the specified name from the URL 
     * search path. Any URLs are searched 
     * until the class is found.
     * @throws ClassNotFoundException if the named class could not be
     * found.
     * @param name the name of the class.
     * @return the resulting class.
     */
    protected java.lang.Class findClass(String name) throws ClassNotFoundException {
	return null;
    }

    /**
     * Creates a new instance of DVBClassLoader for the specified URLs.
     * If a security manager is installed, the <code>loadClass</code>
     * method of the DVBClassLoader returned by this method will invoke
     * the <code>SecurityManager.checkPackageAccess</code> method before
     * loading the class.
     *
     * @param urls the URLs to search for classes and resources.
     * @return the resulting class loader
     */
    public static DVBClassLoader newInstance(URL[] urls){
	return null;
    }
    
    /**
     * Creates a new instance of DVBClassLoader for the specified URLs.
     * If a security manager is installed, the <code>loadClass</code>
     * method of the DVBClassLoader returned by this method will invoke
     * the <code>SecurityManager.checkPackageAccess</code> method before
     * loading the class.
     * 
     * @param urls the URLs to search for classes and resources.
     * @param parent the parent class loader for delegation.
     * @return the resulting class loader
     */
    public static DVBClassLoader newInstance(URL[] urls,
                                             ClassLoader parent){
	return null;

    }
   
   }

