/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.media;



/**

 * A control to support the setting and querying of the video

 * presentation for background players.

 */



public interface BackgroundVideoPresentationControl

extends VideoPresentationControl 

{

	/**

	 * Sets a new video transformation (clipping/scaling/positioning). If

	 * the new video transformation is not supported, then the video

	 * transformation will not be changed at all (no best effort attempt

	 * is made).

	 * 

	 * @param t the new video transformation

	 * 

	 * @return true if the video transformation is supported and has been

	 * set, false otherwise.

	 */

	public abstract boolean setVideoTransformation(VideoTransformation t);

	

	/**

	 * Return the current video transformation

	 *

	 * @return the video transformation (clipping/scaling/positioning)

	 * that is currently used for displaying the video.

	 */

	public abstract VideoTransformation getVideoTransformation();

	

	/**

	 * This method takes a video transformation and returns the closest

	 * match of that video transformation that can be supported for the 

	 * currently selected video. If the input video transformation can

	 * be supported, then the output video transformation will have the

	 * same parameters as the input video transformation. The definition

	 * of 'closest match' is implementation dependent.

	 * 

	 * @param t the input video transformation

	 * 

	 * @return the closest match to the input video transformation. If the

	 * input video transformation is supported, then the input video

	 * transformation will be returned (the same instance), otherwise

	 * a newly created instance will be returned.

	 */

	public abstract VideoTransformation getClosestMatch(VideoTransformation t);

}


