/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.media;

import javax.tv.locator.InvalidLocatorException;

import javax.tv.service.selection.InvalidServiceComponentException;

import javax.tv.service.selection.InsufficientResourcesException;

import javax.tv.locator.Locator;

/**
 * DVBMediaSelectControl extends <code>MediaSelectControl</code> allowing
 * the selection of different kinds of content in a running <code>Player</code>.
 * The extension is to allow the selection in a single operation of all the
 * media service components in a service without needing knowledge about which 
 * media service components are present in that service.
 * @see javax.tv.media.MediaSelectControl
 * @since MHP 1.0.2
 */

public interface DVBMediaSelectControl extends javax.tv.media.MediaSelectControl
{
        /**
         * Selects for presentation the media service components from a service.
         * If some content is currently playing, it is replaced in its entirety 
         * by the media service components from the specified service. 
         * This is an asynchronous operation that is completed upon receipt of a 
         * MediaSelectEvent. Note that for most selections that imply a different 
         * time base or otherwise change synchronization relationships, a 
         * RestartingEvent will be posted by the Player. The rules for deciding which
	 * media service components shall be presented are defined in the main body
	 * of the present document.
         * @param l the locator for a service
         * @throws InvalidLocatorException If the locator provided does not reference 
         *         a service.
         * @throws InvalidServiceComponentException If the locator provided does not
         *         reference a service which contains at least one media service component
         * @throws InsufficientResourcesException If the operation cannot be completed 
         *         due to a lack of system resources.
         */
        public void selectServiceMediaComponents(Locator l) throws
                        InvalidLocatorException,InvalidServiceComponentException,
                        InsufficientResourcesException;
            
}


