/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.media;

/**
  * This class represents a permission to access the drip feed mode.
  * 
  */

public class DripFeedPermission extends java.security.BasicPermission
{
  /**
    * Create a new DripFeedPermission. 
    * <p>
    * The value of the name parameter may be ignored by implementations, 
    * and the value passed to the superclass may be a non-empty string 
    * even when this constructor is invoked with an empty string for the name parameter.
    * Therefore, the getName method may return the same non-empty string 
    * regardless of the value passed in the constructor.
    * @param name the name string is currently unused and should be empty
    */
  public DripFeedPermission(String name) {super(name);}
  
  /**
    * Create a new DripFeedPermission. This constructor is used by the policy class 
    * to instantiate new permission objects.
    * <p>
    * The value of the name parameter may be ignored by implementations, 
    * and the value passed to the superclass may be a non-empty string 
    * even when this constructor is invoked with an empty string for the name parameter.
    * Therefore, the getName method may return the same non-empty string 
    * regardless of the value passed in the constructor.
    *
    * @param name The name string is currently unused and should be empty
    * @param actions The actions string is currently unused 
    * and should be null. 
    */
  public DripFeedPermission(String name, String actions) {super(name,actions);}

  /**
   * Checks if the specified permission is "implied" by this object.
   * <p>
   * Since name and actions are not used, the only check needed is
   * whether p is also a DripFeedPermission.
   * @param p the permission to check against.
   * @return true if the passed permission is equal to or implied by
   * this permission, false otherwise.
   */
   public boolean implies (java.security.Permission p) {
     return false;
   }

}


