/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.net;



import java.net.*;





/**

 * This class provides additional control over buffering for <code>DatagramSocket</code>s.

 */



public class DatagramSocketBufferControl {



	/**

	 * non-public constructor to stop javadoc generating a public one

	 */

	DatagramSocketBufferControl(){}



  /**

    Sets the SO_RCVBUF option to the specified value for this

    DatagramSocket. The SO_RCVBUF option is used by the platform's

    networking code as a hint for the size to use when allocating the

    underlying network I/O buffers.<p>



    Increasing buffer size can increase the performance of network I/O

    for high-volume connection, while decreasing it can help reduce

    the backlog of incoming data.  For UDP, this sets the buffer size

    for received packets.<p>



    Because SO_RCVBUF is a hint, applications that want to verify what

    size the buffers were set to should call getReceiveBufferSize.



    This method shall throw IllegalArgumentException - if size is 0 or is negative.



    @param d The DatagramSocket for which to change the receive buffer

    size.



    @param size The requested size of the receive buffer, in bytes.



    @throws SocketException - If there is an error when setting the

    SO_RCVBUF option.



  */

  public static void setReceiveBufferSize(DatagramSocket d, int size)

    throws java.net.SocketException {}



  /**



    Get value of the SO_RCVBUF option for this socket, that is the

    buffer size used by the platform for input on the this Socket.

    The value returned need not be the value previously set by setReceiveBufferSize (if any).



    @param d The DatagramSocket for which to query the receive buffer

    size.



    @return The size of the receive buffer, in bytes.



    @throws SocketException - If there is an error when querying the

    SO_RCVBUF option.

  */



  public static int getReceiveBufferSize(DatagramSocket d)

    throws java.net.SocketException {return 0;}

}




