/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.user;



/**

 * This class is for user preference and setting permissions. A

 * UserPreferencePermission contains a name, 

 * but no actions list.

 * <p>

 * The permission name can either be "read" or "write". The

 * "read" permission allows an application to read the user

 * preferences and settings (using <code>UserPreferenceManager.read</code>) for

 * which read access is not always granted. Access to

 * the following settings/preferences is always granted:

 * "User Language", "Parental Rating", "Default Font Size" and "Country Code" 

 * <p>

 * The "write" permission allows

 * an application to modify user preferences and settings

 * (using <code>UserPreferenceManager.write</code>).

 */



public class UserPreferencePermission

	extends java.security.BasicPermission

{

	/**

	 * Creates a new UserPreferencePermission with the 

         * specified name. The name is the symbolic name of the 

         * UserPreferencePermission.

	 * 

	 * @param name the name of the UserPreferencePermission

	 */

	public UserPreferencePermission(String name)

	{

		super(name);

	}



	/** 

	 * Creates a new UserPreferencePermission object with the specified 

	 * name. The name is the symbolic name of the UserPreferencePermission, 

	 * and the actions String is unused and should be null. 

	 * This constructor exists for use by the Policy object to 

	 * instantiate new Permission objects.

	 *

	 * @param name the name of the UserPreferencePermission

	 * @param actions should be null.

	*/

	public UserPreferencePermission(String name, String actions)

	{

		super(name,actions);

	}

}


