/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/**

   The {@link org.havi.ui.HFlatMatte HFlatMatte} class represents a

   matte that is constant over space and time. It is specified as a

   floating point value in the range 0.0 to 1.0 where:

   <ul>

   <li>0.0 is fully transparent

   <li>values between 0.0 and 1.0 are partially transparent to the

   nearest supported transparency value.

   <li>1.0 is fully opaque

   </ul>



  <hr>

  The parameters to the constructors are as follows, in cases where

  parameters are not used, then the constructor should use the default

  values.

  <p>

  <h3>Default parameter values exposed in the constructors</h3>

  <table border>

  <tr><th>Parameter</th><th>Description</th><th>Default value</th> 

  <th>Set method</th><th>Get method</th></tr>

 <tr>

    <td>data</td>

    <td>The transparency value for this flat effect matte.</td>

    <td>1.0</td>

    <td>{@link org.havi.ui.HFlatMatte#setMatteData setMatteData}</td>

    <td>{@link org.havi.ui.HFlatMatte#getMatteData getMatteData}</td>

</tr>

  </table>



  <h3>Default parameter values not exposed in the constructors</h3>

  <table border>

  <tr><th>Description</th><th>Default value</th><th>Set method</th>

  <th>Get method</th></tr>

  <tr><td colspan=4>None.</td></tr>

  </table>



*/



public class HFlatMatte

    implements HMatte

{

    

    /**

     * Creates an {@link org.havi.ui.HFlatMatte HFlatMatte}

     * object. See the class description for details of constructor

     * parameters and default values.  

     */

    public HFlatMatte()

    {

    }



    /**

     * Creates an {@link org.havi.ui.HFlatMatte HFlatMatte}

     * object. See the class description for details of constructor

     * parameters and default values.

     */

    public HFlatMatte(float data)

    {

    }



    /**

     * Sets the data for this matte. Any previously set data is replaced.

     *

     * @param data the data for this matte.

     */

    public void setMatteData(float data)

    {

    }



    /**

     * Returns the data used for this matte.

     *

     * @return the data used for this matte (a single number).

     */

    public float getMatteData()

    {

        return (1.0f);

    }

}


