/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/**

  This {@link org.havi.ui.HMatteLayer HMatteLayer} interface enables

  the presentation of components, together with an associated {@link

  org.havi.ui.HMatte HMatte}, for matte compositing.

  

  @see HMatte

*/



public interface HMatteLayer 

{

    /**	

     * Applies an {@link org.havi.ui.HMatte HMatte} to this component,

     * for matte compositing. Any existing animated matte must be

     * stopped before this method is called or an HMatteException will

     * be thrown.

     * 

     * @param m The {@link org.havi.ui.HMatte HMatte} to be applied to

     * this component -- note that only one matte may be associated

     * with the component, thus any previous matte will be replaced.

     * If m is null, then any matte associated with the component is

     * removed and further calls to getMatte() shall return null. The

     * component shall behave as if it had a fully opaque {@link

     * org.havi.ui.HFlatMatte HFlatMatte} associated with it (i.e an

     * HFlatMatte with the default value of 1.0.)

     * @exception HMatteException if the {@link org.havi.ui.HMatte

     * HMatte} cannot be associated with the component. This can occur:

     * <ul>

     * <li> if the specific matte type is not supported

     * <li> if the platform does not support any matte type

     * <li> if the component is associated with an already running

     * {@link org.havi.ui.HFlatEffectMatte HFlatEffectMatte} or {@link

     * org.havi.ui.HImageEffectMatte HImageEffectMatte}. The exception

     * is thrown even if m is null.

     * </ul>

     * @see HMatte 

     */

    public void setMatte(HMatte m) throws HMatteException;



    /**

     * Get any {@link org.havi.ui.HMatte HMatte} currently associated

     * with this component.

     * 

     * @return the {@link org.havi.ui.HMatte HMatte} currently

     * associated with this component or null if there is no

     * associated matte.  

     */

    public HMatte getMatte();

}








