/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



import org.havi.ui.event.HFocusEvent;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/** 

    A component which implements {@link

    org.havi.ui.HNavigationInputPreferred}

    indicates that this component expects to receive {@link

    org.havi.ui.event.HFocusEvent} events. The focus event

    system in HAVi is designed to be compatible with standard AWT

    focus mechanisms while supporting key event-based focus traversal

    for HAVi UI components.<p>

   

   All interoperable implementations of the {@link

    org.havi.ui.HNavigationInputPreferred}

   interface must extend {@link org.havi.ui.HComponent HComponent}.



    <p> 

    Components which implement {@link

    org.havi.ui.HNavigationInputPreferred}

    to handle {@link org.havi.ui.event.HFocusEvent} events

    can optionally manage focus traversal based on keyboard input

    events, in addition to the normal semantics of the {@link

    org.havi.ui.event.HFocusEvent#FOCUS_GAINED} and

    {@link org.havi.ui.event.HFocusEvent#FOCUS_LOST} event

    types. The focus traversal mechanism specified by the HAVI UI

    {@link org.havi.ui.HNavigable} interface is one such

    system.



    <p>

    In the case where such an implementation requires specific keys to

    manage focus traversal the {@link

    org.havi.ui.HNavigationInputPreferred#getNavigationKeys}

    method is provided to allow the HAVi platform

    to query the set of keys for which a navigation target has been

    set. When such a component has the input focus, platforms without

    a physical means of generating the desired keystrokes shall

    provide another means for navigation e.g. by offering an on-screen

    &quot;virtual&quot; keyboard. Applications can query the system about

    the support of specific keyCodes through the {@link

    org.havi.ui.event.HKeyCapabilities#isSupported} method.<p>

    

    The keyCodes for navigation keystrokes generated on the {@link

    org.havi.ui.HNavigationInputPreferred} will be passed to the {@link

    org.havi.ui.HNavigationInputPreferred} as an {@link

    org.havi.ui.event.HFocusEvent} transferId through the {@link

    org.havi.ui.HNavigationInputPreferred#processHFocusEvent} method. No {@link

    org.havi.ui.event.HKeyEvent} will be generated on the {@link

    org.havi.ui.HNavigationInputPreferred} as a result of these keystrokes.



    <p> 

    Note that the java.awt.Component method isFocusTraversable should

    always return true for a <code>java.awt.Component</code>

    implementing this interface.  */



public interface HNavigationInputPreferred 

{

    /**

     * Retrieve the set of key codes which this component maps to

     * navigation targets. 

     *

     * @return an array of key codes, or <code>null</code> if no

     * navigation targets are set on this component.  

     */

    public int[] getNavigationKeys();



     /**

     * Process an {@link org.havi.ui.event.HFocusEvent

     * HFocusEvent} sent to this {@link org.havi.ui.HNavigationInputPreferred

     * HNavigationInputPreferred}.

     * 

     * @param evt the {@link org.havi.ui.event.HFocusEvent

     * HFocusEvent} to process. 

     */

     

	public void processHFocusEvent(org.havi.ui.event.HFocusEvent evt);



}


