/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui.event;



import java.util.EventObject;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/** 

    This event informs an application that a loading operation for an

    {@link org.havi.ui.HBackgroundImage HBackgroundImage} has

    finished.



  <hr>

  The parameters to the constructors are as follows, in cases where

  parameters are not used, then the constructor should use the default

  values.

  <p>

  <h3>Default parameter values exposed in the constructors</h3>

  <table border>

  <tr><th>Parameter</th><th>Description</th><th>Default value</th> 

  <th>Set method</th><th>Get method</th></tr>

  <tr><td colspan=5>None.</td></tr>

  </table>

  <h3>Default parameter values not exposed in the constructors</h3>

  <table border>

  <tr><th>Description</th><th>Default value</th><th>Set method</th>

  <th>Get method</th></tr>

  <tr><td colspan=4>None.</td></tr>

  </table>



  */



public class HBackgroundImageEvent extends java.util.EventObject

{

    /**

     * Marks the first integer for the range of background image

     * events

     */

    public static final int BACKGROUNDIMAGE_FIRST          = 1;

        

    /**

     * The loading succeeded

     */

    public static final int BACKGROUNDIMAGE_LOADED         = 1;

    

    /**

     * The loading failed before attempting to load any data from 

     * the file. e.g. the file not existing or due to a badly formed 

     * or otherwise broken filename

     */

    public static final int BACKGROUNDIMAGE_FILE_NOT_FOUND = 2;

    

    /**

     * The loading failed due to an error while loading the data. 

     * e.g. the file is not accessible or loading of it was interrupted

     */

    public static final int BACKGROUNDIMAGE_IOERROR        = 3;

    

    /**

     * The loading failed because the data loaded is not valid. e.g.

     * not a supported coding format for background images.

     */

    public static final int BACKGROUNDIMAGE_INVALID        = 4;

    

    /**

     * Marks the last integer for the range of background image events 

     */

    public static final int BACKGROUNDIMAGE_LAST           = 4;



    /**

     * Constructs a new {@link org.havi.ui.event.HBackgroundImageEvent

     * HBackgroundImageEvent}. 

     *

     * @param source the {@link org.havi.ui.HBackgroundImage

     * HBackgroundImage} which has been loaded.  

     * @param id the type of event (one of {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_LOADED

     * BACKGROUNDIMAGE_LOADED}, {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_FILE_NOT_FOUND

     * BACKGROUNDIMAGE_FILE_NOT_FOUND}, {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_IOERROR

     * BACKGROUNDIMAGE_IOERROR} or {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_INVALID

     * BACKGROUNDIMAGE_INVALID}).

     */

    public HBackgroundImageEvent(Object source, int id)

    {

	super(source);

    }



    /**

     * Returns the {@link org.havi.ui.HBackgroundImage

     * HBackgroundImage} for which the data has been loaded.

     *

     * @return the object which has been loaded.  

     */

    public Object getSource()

    {

	return (null);

    }



    /**

     * Returns the type for this event.

     *

     * @return the event type (one of {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_LOADED

     * BACKGROUNDIMAGE_LOADED}, {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_FILE_NOT_FOUND

     * BACKGROUNDIMAGE_FILE_NOT_FOUND}, {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_IOERROR

     * BACKGROUNDIMAGE_IOERROR} or {@link

     * org.havi.ui.event.HBackgroundImageEvent#BACKGROUNDIMAGE_INVALID

     * BACKGROUNDIMAGE_INVALID}).

     */

    public int getID()

    {

	return (0);

    }

}
















