/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.application;

import java.util.*;

/**
 * The <code>AppID</code> is a representation of the unique identifier for 
 * applications.
 * <p> Its string form is the Hex representation of the 48 bit number.
 */
public class AppID {
    /**
     * This method returns the integer value of the organization number supplied in the constructor.
     *
     * @return the integer value of the organization number supplied in the constructor.
     * @since   MHP1.0
     */
    public int getOID(){return 1;};
    
    /**
     * This method returns the integer value of the application count supplied in the constructor 
     *
     * @return the integer value of the application count supplied in the constructor 
     * @since   MHP1.0
     */
    public int getAID(){return 1;};
    
    /**
     * Create a new AppID based on the given integers. There is no range checking on these numbers.
     *
     * @param     oid     the globally unique organization number.
     * @param     aid     the unique count within the organization.
     * @since   MHP1.0
     */
    public AppID(int oid, int aid){}

    /**
     * This method returns a string containing the Hex representation of the 48 bit 
     * number.
     * The string shall be formatted as specified in the clause on "Text encoding of 
     * application identifiers" in the System Integration clause of the MHP specification.
     * 
     * @return a string containing the Hex representation of the 48 bit 
     * number.
     * @since   MHP1.0
     */
    public String toString(){return null;}

   /** Compares two AppIDs for equality.
    * @param   obj   the reference object with which to compare.
    * @return  <code>true</code> if this obj is an AppID
    *          and its Organisation ID and its Application ID
    *          match the IDs for this AppID; <code>false</code> otherwise.
    */
  public boolean equals( Object obj ) {
    return false;
  }

  /** Returns a hash code value for this AppID.
    * The hashcode for two AppIDs with the same Organisation ID
    * and Application ID are equal.
    * @return  a hash code value for this AppID
    */
  public int hashCode() {
    return 0;
  }

}

