/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.application;

/**
 * This class represents a Permission to control the lifecycle
 * of another application.
 */

public final class AppsControlPermission extends java.security.BasicPermission {

	/**
	 * Creates a new AppsControlPermission.
         * There is a simple mapping between the Application control Permission 
         * requests and the way the AppsControlPermission are granted. This mapping
	 * is defined in the main body of the present document.
	 */
	public AppsControlPermission()
	{super("toto");
	}

	/**
	 * Creates a new AppsControlPermission.
         * There is a simple mapping between the Application control Permission 
	 * requests and the way the AppsControlPermission are granted. This mapping is 
	 * defined in the main body of the present document. 
	 * The actions string is currently unused and should be null.
	 * The name string is currently unused and should be empty.
	 * This constructor 
	 * exists for use by the java.security.Policy object to instantiate new 
	 * permission objects.
	 *
	 * @param name the name of the permission
	 * @param actions the actions string
         */
	public AppsControlPermission(String name, String actions)
	{super(name);
	}

        /**
	 * Returns the list of actions that had been passed to the
         * constructor - it shall return null.
	 *
	 * @return a null String.
 	 */
	public String getActions() { return null;}

	/**
	 * Checks if this AppsControlPermission object "implies" the specified permission. 
	 * @param permission the specified permission to check.
	 * @return true if and only if the specified permission is an instanceof AppsControlPermission
	 */
	public boolean implies(java.security.Permission permission) {return true;}

	/**
	 * Checks for equality against this AppsControlPermission object. 
	 *
 	 * @param obj the object to test for equality with this AppsControlPermission object.
	 * @return true if and only if obj is an AppsControlPermission
         */
	public boolean equals(Object obj) { return true;}

	/**
	 * Returns the hash code value for this object.
	 *
	 * @return the hash code value for this object.
         */
	public int hashCode() { return 0 ;}


}

