/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/


   package org.dvb.dsmcc;

   import java.io.*;
   import org.davic.net.*;


/**
  * A ServiceXFRException is thrown when a DSMCC Object can not be loaded in the 
  * current ServiceDomain but is available in an alternate ServiceDomain 
  * (i.e. for an object Carousel, the IOR of the object or one of its
  *  parent directories contains a Lite Option Profile Body).
  * There is no implicit mounting by the implementation of the carousel 
  * that actually contain the object. This exception is not thrown if the 
  * Service Domain that actually contains the DSMCCObject is already mounted.
  *
  */

   public class ServiceXFRException extends DSMCCException {
   
   /**
   * Creates a ServiceXFRException object.
   *
   * @param aService Locator of the Service
   * @param carouselId Carousel Identifier
   * @param pathName pathName of the object in the alternate ServiceDomain
   */
      public ServiceXFRException(org.davic.net.Locator aService, int carouselId,
                        String pathName)
      {
      }
   
   /**
   * Creates a ServiceXFRException object.
   *
   * @param NSAPAddress The NSAP Address of a ServiceDomain as defined
   * in ISO/IEC 13818-6
   * @param pathName pathName of the object in the alternate ServiceDomain
   */
      public ServiceXFRException(byte[] NSAPAddress, String pathName)
      {
      }
   
   /**
   * This method is used to get the alternate ServiceDomain which contains
   * the object requested.
   * @return the address of an alternate ServiceDomain where the object can
   * be found.
   */
      public ServiceXFRReference getServiceXFR()
      { return null;
      }
   }

