/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/






   package org.dvb.dsmcc;



   import java.io.*;

   import org.davic.net.*;





/**

  * A ServiceXFRReference object is used when a DSMCC Object can not

  * be loaded in the current ServiceDomain but is available

  * in an alternate ServiceDomain.

  * Instances of this class are just containers. The parameters passed are merely 

  * stored and returned by the access methods. It is the responsibility of the 

  * platform when generating instances to use correct values.

  *

  */



   public class ServiceXFRReference  {

   

   

   /**

   * Creates a ServiceXFRReference object.

   *

   * @param serviceLocator Locator of the Service

   * @param carouselId Carousel Identifier

   * @param pathName pathName of the object in the alternate ServiceDomain

   */

      public ServiceXFRReference(org.davic.net.Locator serviceLocator, 

                        int carouselId, String pathName) {

      }

   

   /**

   * Creates a ServiceXFRReference object.

   *

   * @param nsapAddress The NSAP Address of a ServiceDomain as defined

   * in ISO/IEC 13818-6

   * @param pathName pathName of the object in the alternate ServiceDomain

   */

      public ServiceXFRReference(byte[] nsapAddress, String pathName)

      {

      }

   

   /**

   * This method returns the Locator of the Service for an Object Carousel.

   *

   * @return the Locator of the Service for an Object Carousel.

   * This method returns null, if the ServiceDomain is not associated with 

   * an Object Carousel. In this case the NSAP address must be used instead.

   */  

      public org.davic.net.Locator getLocator()

      {return null;

      }

   

   /**

    * This method returns the carousel identifier. If the object was constructed

    * using the constructor which includes a carousel ID or if it was

    * constructed using the constructor which includes an NSAP address and that 

    * NSAP address contains a carouselID then this method shall return that

    * carousel ID otherwise this method shall return -1.

    *

    * @return the carousel identifier or -1.

    */  

      public int getCarouselId()

      { return 0;

      }

   

   /**

   * This method returns the pathname of the object in the alternate ServiceDomain.

   *

   * @return the pathname of the object in the alternate ServiceDomain.

   */  

      public String getPathName()

      {return null;

      }

   

   /**

   * This method returns the NSAP Address of a ServiceDomain as defined

   * in ISO/IEC 13818-6. If the object was constructed using an NSAP address

   * then this method shall return the NSAP address passed into the

   * constructor. If the object was constructed with a locator and a carouselID 

   * then this method shall return an NSAP address derived from this information 

   * when locator is an instance of org.davic.net.dvb.DVBLocator. Otherwise 

   * this method shall return null

   * @return the NSAP Address of a ServiceDomain as defined in ISO/IEC 13818-6 or null

   */ 

      public byte[] getNSAPAddress()

      {return null;

      }

   

   }


