/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.event ;

 /**
  * An instance of this class will be sent to clients of the
  * DVB event API to notify them (through the interface
  * org.davic.resources.ResourceClient) when they are about to
  * lose, or have lost, access to an event source. This object
  * can be used by the application to get the name of the
  * repository from which it will no longer be able to receive
  * events.
  * All instances of RepositoryDescriptor are also instances of UserEventRepository.
  * This class is preserved for backwards compatibility with existing applications.
  */
public class RepositoryDescriptor 
    implements org.davic.resources.ResourceProxy {
   
	/**
	 * package-private constructor for parent classes
	 */
    RepositoryDescriptor () {}
    
    /**
     * Returns the name of the repository to which the lost, or about to be lost, user event belongs.
     *
     * @return String the name of the repository.
     */
    public String getName () {return null;}
    
    /**
     * Return the object which asked to be notified about withdrawal of the event
     * source. This is the object passed as the <code>ResoourceClient</code> to 
     * whichever of the various 'add' methods on EventManager was used by the
     * application to express interest in this repository.
     *
     * @return the object which asked to be notified about withdrawal of the event source.
     * If the <code>UserEventRepository</code> has not yet been added to an <code>EventManager</code>
     * then null shall be returned. Once the <code>UserEventRepository</code> has been added, the 
     * last used <code>ResourceClient</code> shall be returned even if the <code>UserEventRepository</code>
     * has been since removed. 
     */
    public org.davic.resources.ResourceClient getClient() { return null;}
}




