/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.net.rc;



import java.net.InetAddress;



/**

 * This class encapsulates the parameters needed to specify the target

 * of a connection. 

 */



public class ConnectionParameters {

	/**

	 * Construct a set of connection parameters. Details of the DNS server to use are

	 * supplied by the server.

	 *

	 * @param number the target of the connection, e.g. a phone number

	 * @param username the username to use in connection setup

	 * @param password the password to use in connection setup

	 */

	public ConnectionParameters(String number, String username, String password)

	{

	}

	/**

	 * Construct a set of connection parameters.

	 *

	 * @param number the target of the connection, e.g. a phone number

	 * @param username the username to use in connection setup

	 * @param password the password to use in connection setup

	 * @param dns the list of DNS servers to try before reporting failure. The order in 

	 * which they are interrogated is not specified. Once one result has been obtained, 

	 * there is no requirement to try others.

	 */

	public ConnectionParameters(String number, String username, String password, InetAddress[] dns)

	{

	}

	/**

	 * Return the target of this connection for example a phone number.

         * The value returned shall be the one passed into the constructor of this instance.

	 *

	 * @return the target of the connection

	 */

	public String getTarget()

	{

		return null;

	}

	/**

	 * Return the username used in establishing this connection

         * The value returned shall be the one passed into the constructor of this instance.

	 *

	 * @return the username used in establishing the connection

	 */

	public String getUsername()

	{

		return null;

	}

	/**

	 * Return the password used in establishing this connection

         * The value returned shall be the one passed into the constructor of this instance.

	 *

	 * @return the password used in establishing this connection

	 */

	public String getPassword() 

	{

		return null;

	}

	/**

	 * Return the addresses of the DNS servers to use for the connection

	 *

	 * @return return the addresses of the DNS servers passed into the 

	 * constructor of the instance or null if none was provided.

	 */

	public InetAddress[] getDNSServer() 

	{

		return null;

	}

}


