/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.dvb.net.rc;

import java.net.*;

import org.davic.resources.*;

/**
 * This class is the factory and manager for all return channel interfaces in the system.
 * The methods on this class which return instances of the <code>RCInterface</code>
 * will only return new instances of that class under the following conditions:
 * <ul>
 * <li>on the first occasion an instance needs to be returned to a particular application for a particular interface.
 * <li>when new return channel interfaces are added to the system
 * </ul>
 */

public class RCInterfaceManager implements org.davic.resources.ResourceServer {
	/**
	 * package scope constructor to stop javadoc generating one
	 */
	RCInterfaceManager()
	{
	}

	/**
	 * Factory method to obtain a manager.
	 * The RCInterfaceManager is either a singleton for each MHP application or a singleton for the MHP terminal.
	 *
	 * @return an instance of an RCInterfaceManager
	 */
	public static RCInterfaceManager getInstance()
	{
		return null;
	}
	/**
	 * Factory method to return a list of all return channel interfaces
	 * visible to this application. The number of entries in the array will 
	 * exactly match the number of return channel interfaces visible to 
	 * the application. Null is returned if no interfaces are visible to 
	 * this application. 
	 *
	 * @return an array of available return channel interfaces
 	 */
	public RCInterface[] getInterfaces()
	{
		return null;
	}
	/**
	 * Return the interface which will be used when connecting to a particular host.
	 * Null is returned if this is not known when the method is called. 
	 *
	 * @param addr the IP address of the host to connect to
	 * @return the interface which will be used or null if this is not known
	 */
	public RCInterface getInterface(InetAddress addr) 
	{
		return null;
	}
	/**
	 * Return the interface which is used for a particular socket.
	 *
	 * @param s the socket to use
	 * @return the interface which is used or null if the socket is not connected
	 */
	public RCInterface getInterface(Socket s) 
	{
		return null;
	}
	/**
	 * Return the interface which is used for a particular URLConnection
	 *
	 * @param u the URLConnection to use
	 * @return the interface which is used or null if the URLConnection is not connected
	 */
	public RCInterface getInterface(URLConnection u) 
	{
		return null;
	}
	/**
	 * This method informs a resource server that a particular object should be 
	 * informed of changes in the state of the resources managed by that server.
	 *
	 * @param listener the object to be informed of state changes
	 */

	public void addResourceStatusEventListener (ResourceStatusListener listener)
	{
	}

	/**
	 * This method informs a resource server that a particular object is no 
	 * longer interested in being informed about changes in state of resources 
	 * managed by that server. If the object had not registered its interest 
	 * initially then this method has no effect.
	 *
	 * @param listener the object which is no longer interested
	 */

	public void removeResourceStatusEventListener(ResourceStatusListener listener)
	{
	}
}


