/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/**

   The {@link org.havi.ui.HImageHints HImageHints} object allows an

   application to pass hints to the system how best to tailor an image

   to match a (possibly) restricted {@link

   org.havi.ui.HGraphicsConfiguration HGraphicsConfiguration}.



  <hr>

  The parameters to the constructors are as follows, in cases where

  parameters are not used, then the constructor should use the default

  values.

  <p>

  <h3>Default parameter values exposed in the constructors</h3>

  <table border>

  <tr><th>Parameter</th><th>Description</th><th>Default value</th> 

  <th>Set method</th><th>Get method</th></tr>

<tr><td></td><td></td><td></td><td></td><td></td></tr>

  </table>



  <h3>Default parameter values not exposed in the constructors</h3>

  <table border>

  <tr><th>Description</th><th>Default value</th><th>Set method</th>

  <th>Get method</th></tr>

<tr>

<td>The image type.</td> 

<td>{@link org.havi.ui.HImageHints#NATURAL_IMAGE NATURAL_IMAGE}</td> 

<td>---</td> 

<td>---</td>

</tr>

  </table>



*/



public class HImageHints extends Object 

{

    /**

     * The image is a &quot;natural&quot; scene, with subtle gradations

     * of color, etc.  Suitable for dithering.

     */

    public static final int NATURAL_IMAGE = 0x01;

    

    /**

     * The image is a cartoon, with strong, well-defined, blocks of

     * solid color, etc.  Not suitable for dithering, suitable for

     * nearest color matching.

     */

    public static final int CARTOON = 0x02;

    

    /**

     * The image is business graphics, with strong, well-defined, blocks

     * of solid color, etc.  Not suitable for dithering, suitable for

     * nearest color matching.    

     */

    public static final int BUSINESS_GRAPHICS = 0x03;

    

    /**      

     * The image is a two-tone lineart, with colors varying between

     * foreground and background, etc. Not suitable for dithering.

     * Possibly suitable for color-map adjustment, etc., if

     * applicable.    

     */

    public static final int LINE_ART = 0x04;

    

    /**

     * Creates an HImageHints object. See the class description for

     * details of constructor parameters and default values.  

     */

    public HImageHints()

    {

    }

    

    /**

     * Set the expected type of the image being loaded.  

     * 

     * @param type the expected type of image 

     */

    public void setType(int type)

    {

    }

    

    /**    

     * Get the expected type of the image being loaded.    

     */

    public int getType()

    {

	return(0);

    }

}


















