/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */





/**

   The {@link org.havi.ui.HOrientable HOrientable} interface provides

   support for components which have an orientation. <p>

   

   Widgets of HAVi compliant applications implementing the

   <code>HOrientable</code> interface must have

   <code>HComponent</code> in their inheritance tree.

*/



public interface HOrientable

{

    /** 

     * A constant which specifies that the {@link org.havi.ui.HOrientable

     * HOrientable} shall be rendered with a horizontal orientation,

     * with the minimum value on the left side, and the maximum

     * value on the right side.  

     */

    public static final int ORIENT_LEFT_TO_RIGHT = 0;



    /** 

     * A constant which specifies that the {@link org.havi.ui.HOrientable

     * HOrientable} shall be rendered with a horizontal orientation,

     * with the minimum value on the right side, and the maximum value

     * on the left side.

     */

    public static final int ORIENT_RIGHT_TO_LEFT = 1;

    

    /** 

     * A constant which specifies that the {@link org.havi.ui.HOrientable

     * HOrientable} shall be rendered with a vertical orientation, with

     * the minimum value on the top, and the maximum of the range

     * on the bottom.  

     */

    public static final int ORIENT_TOP_TO_BOTTOM = 2;

    

    /** 

     * A constant which specifies that the {@link org.havi.ui.HOrientable

     * HOrientable} shall be rendered with a vertical orientation, with

     * the minimum value on the bottom, and the maximum value on

     * the top.  

     */

    public static final int ORIENT_BOTTOM_TO_TOP = 3;



    /**

     * Retrieve the orientation of the {@link org.havi.ui.HOrientable

     * HOrientable}. The orientation controls the layout of the component.

     *

     * @return one of {@link

     * org.havi.ui.HOrientable#ORIENT_LEFT_TO_RIGHT

     * ORIENT_LEFT_TO_RIGHT}, {@link

     * org.havi.ui.HOrientable#ORIENT_RIGHT_TO_LEFT

     * ORIENT_RIGHT_TO_LEFT}, {@link

     * org.havi.ui.HOrientable#ORIENT_TOP_TO_BOTTOM

     * ORIENT_TOP_TO_BOTTOM}, or {@link

     * org.havi.ui.HOrientable#ORIENT_BOTTOM_TO_TOP

     * ORIENT_BOTTOM_TO_TOP}.  

     */

    public int getOrientation();



    /**

     * Set the orientation of the {@link org.havi.ui.HOrientable

     * HOrientable}. The orientation controls the layout of the component.

     *

     * @param orient one of {@link

     * org.havi.ui.HOrientable#ORIENT_LEFT_TO_RIGHT

     * ORIENT_LEFT_TO_RIGHT}, {@link

     * org.havi.ui.HOrientable#ORIENT_RIGHT_TO_LEFT

     * ORIENT_RIGHT_TO_LEFT}, {@link

     * org.havi.ui.HOrientable#ORIENT_TOP_TO_BOTTOM

     * ORIENT_TOP_TO_BOTTOM}, or {@link

     * org.havi.ui.HOrientable#ORIENT_BOTTOM_TO_TOP

     * ORIENT_BOTTOM_TO_TOP}.  

     */

    public void setOrientation(int orient);

}


