/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/**

   {@link org.havi.ui.HScreenDimension HScreenDimension} denotes a

   screen dimension expressed as a relative value of the screen

   dimensions. Note that since these are relative dimensions they are

   effectively independent of any particular screen's physical

   dimensions, or aspect ratio.



   <p> 

   Note that the extents of the dimension must be positive

   (including zero), but are otherwise unconstrained - and hence may

   denote areas greater in size than the entire screen.



   <p>

   

   Hence,

   <ul>

   <li>(1.0, 1.0) denotes the size of the entire screen.

   <li>(0.5, 0.5) denotes a quarter of the screen.

   </ul>



   Note that in practice, particularly in the case of television, the

   precise dimension may vary slightly due to effects of overscan, etc.



   <p>   

   Note that systems using {@link org.havi.ui.HScreenDimension

   HScreenDimensions} directly should consider the effects of rounding

   errors, etc.



  <hr>

  The parameters to the constructors are as follows, in cases where

  parameters are not used, then the constructor should use the default

  values.

  <p>

  <h3>Default parameter values exposed in the constructors</h3>

  <table border>

  <tr><th>Parameter</th><th>Description</th><th>Default value</th> 

  <th>Set method</th><th>Get method</th></tr>

<tr>

  <td>width</td>

  <td>The horizontal extent of the dimension</td>

  <td>no default constructor exists</td>

  <td>{@link org.havi.ui.HScreenDimension#setSize setSize}</td>

  <td>---</td>

</tr>



<tr>

  <td>height</td>

  <td>The vertical extent of the dimension</td>

  <td>no default constructor exists</td>

  <td>{@link org.havi.ui.HScreenDimension#setSize setSize}</td>

  <td>---</td>

</tr>

  </table>



  <h3>Default parameter values not exposed in the constructors</h3>

  <table border>

  <tr><th>Description</th><th>Default value</th><th>Set method</th>

  <th>Get method</th></tr>

  <tr><td colspan=4>None.</td></tr>

  </table>



 @see HScreenPoint



*/

public class HScreenDimension

    extends Object

{

    public float width;

    public float height;



    /**

     * Creates an {@link org.havi.ui.HScreenDimension

     * HScreenDimension} object.  See the class description for

     * details of constructor parameters and default values.  

     */

    public HScreenDimension(float width, float height)

    {

    }



    /**

     * Set the extents of the HScreenDimension.

     *

     * @param width the horizontal extent of the HScreenDimension

     * @param height the vertical extent of the HScreenDimension

     */

    public void setSize(float width, float height)

    {

    }

}


