/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



/**

 * The <code>HVersion</code> interface defines some

 * versioning constants that are accessible by using the

 * java.lang.System method getProperty, with the appropriate property

 * name.

 * <p>

 * Note that it is a valid implementation to return empty strings for

 * HAVI_IMPLEMENTATION_NAME, HAVI_IMPLEMENTATION_VENDOR and

 * HAVI_IMPLEMENTATION_VERSION strings.

 * <p>

 * In MHP, a call to <code>getProperty()</code> when referencing the

 * constants listed in column <i>Constant</i> in the table below

 * shall return a string as listed in column <i>Value</i>.

 * <table border>

 *   <tr><th>Constant</th><th>Value</th></tr>

 *   <tr><td>HAVI_SPECIFICATION_VENDOR</td>

 *       <td>&quot;DVB&quot;</td></tr>

 *   <tr><td>HAVI_SPECIFICATION_NAME</td>

 *       <td>&quot;MHP&quot;</td></tr>

 *   <tr><td>HAVI_SPECIFICATION_VERSION</td>

 *       <td>&quot;&lt;version&gt;&quot;</td></tr>

 * </table>

 * &quot;&lt;version&gt;&quot; shall be the MHP version to which this

 * HAVi implementation is conformant, e.g.: &quot;1.0&quot; or

 * &quot;1.0.1&quot; or &quot;1.0.2&quot; or &quot;1.0.3&quot;.

 */



public interface HVersion 

{

    /** 

     * A string constant describing the HAVi specification vendor, as

     * returned via

     * java.lang.System.getProperty(HVersion.HAVI_SPECIFICATION_VENDOR).  

     */

    public static final String HAVI_SPECIFICATION_VENDOR = 

      "havi.specification.vendor";



    /** 

     * A string constant describing the HAVi specification name, as

     * returned via

     * java.lang.System.getProperty(HVersion.HAVI_SPECIFICATION_NAME).

     */

    public static final String HAVI_SPECIFICATION_NAME = 

      "havi.specification.name";



        

    /** 

     * A string constant describing the HAVi specification version, as

     * returned via

     * java.lang.System.getProperty(HVersion.HAVI_SPECIFICATION_VERSION).

     */

    public static final String HAVI_SPECIFICATION_VERSION = 

      "havi.specification.version";



    /** 

     * A string constant describing the HAVi implementation vendor, as

     * returned via

     * java.lang.System.getProperty(HVersion.HAVI_IMPLEMENTATION_VENDOR).

     */

    public static final String HAVI_IMPLEMENTATION_VENDOR = 

      "havi.implementation.vendor"; 

        

    /** 

     * A string constant describing the HAVi implementation version,

     * as returned via

     * java.lang.System.getProperty(HVersion.HAVI_IMPLEMENTATION_VERSION).

     */

    public static final String HAVI_IMPLEMENTATION_VERSION = 

      "havi.implementation.version"; 

        

    /** 

     * A string constant describing the HAVi implementation name, as

     * returned via

     * java.lang.System.getProperty(HVersion.HAVI_IMPLEMENTATION_NAME).

     */

    public static final String HAVI_IMPLEMENTATION_NAME = 

      "havi.implementation.name"; 



}


