/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */



import java.awt.Container;

import org.havi.ui.event.*;



/**

   {@link org.havi.ui.HVideoComponent HVideoComponent} is an opaque

   class encapsulating the presentation of a video source

   <i>within</i> an application, i.e. contained within a conventional

   AWT hierarchy.

   <p>

   An {@link org.havi.ui.HVideoComponent HVideoComponent} obeys all

   conventional java.awt.Component semantics, including being clipped

   by its parent container, etc. An {@link org.havi.ui.HVideoComponent

   HVideoComponent} also obeys all {@link org.havi.ui.HComponent

   HComponent} semantics including Z-ordering, etc.





  <hr>

  The parameters to the constructors are as follows, in cases where

  parameters are not used, then the constructor should use the default

  values.

  <p>

  <h3>Default parameter values exposed in the constructors</h3>

  <table border>

  <tr><th>Parameter</th><th>Description</th><th>Default value</th> 

  <th>Set method</th><th>Get method</th></tr>

  <tr><td colspan=5>None.</td></tr>

  </table>

  <h3>Default parameter values not exposed in the constructors</h3>

  <table border>

  <tr><th>Description</th><th>Default value</th><th>Set method</th>

  <th>Get method</th></tr>

  <tr><td colspan=4>None.</td></tr>

  </table>



*/



public class HVideoComponent

    extends HComponent

{    

    /**

     * It is not intended that applications should directly construct

     * {@link org.havi.ui.HVideoComponent HVideoComponent} objects.

     * <p>

     * Creates an {@link org.havi.ui.HVideoComponent HVideoComponent}

     * object. See the class description for details of constructor

     * parameters and default values.

     */

    protected HVideoComponent()

    {

    }



    /**

     * Returns the {@link org.havi.ui.HVideoDevice HVideoDevice} that

     * this {@link org.havi.ui.HVideoComponent HVideoComponent} is

     * associated with.

     *

     * @return the {@link org.havi.ui.HVideoDevice HVideoDevice} that

     * this {@link org.havi.ui.HVideoComponent HVideoComponent} is

     * associated with, or null if this cannot be determined.

     */

    public HVideoDevice getVideoDevice()

    {

        return (null);

    }



    /**

     * Register a listener to determine if the Component's on-screen

     * location is modified - irrespective of its relative location to

     * its parent Container. If the listener has already been added

     * further calls will add further references to the listener,

     * which will then receive multiple copies of a single event.

     *

     * @param slml listener to be notified when the on-screen location

     * of the component is modified.  

     */

    public void addOnScreenLocationModifiedListener(HScreenLocationModifiedListener slml)

    {

    }



    /**

     * Remove a listener that determines if the Component's on-screen

     * location is modified - irrespective of its relative location to

     * its parent Container. If the specified listener is not

     * registered, the method has no effect.  If multiple references to

     * a single listener have been registered it should be noted that

     * this method will only remove one reference per call.

     *

     * @param slml slml - listener to be removed

     */

    public void removeOnScreenLocationModifiedListener(HScreenLocationModifiedListener slml)

    {

    }

}


