/**
<P>This is not an official specification document, and usage is restricted.
</p>
<a name="notice"><strong><center>
NOTICE
</center></strong><br>
<br>
Copyright (c) 2008 by the DVB Project
<p>
Neither this file, nor any file generated from it, describes a 
complete specification, and any such file may be used only as 
described below. For example, no permission is given for you 
to incorporate this file, in whole or in part, in an 
implementation of a GEM terminal specification.
<p>
The DVB Project owns the copyright in this file and it is provided 
to you for informative, as opposed to normative, use. The file 
and any file generated from it may be used to generate other 
informative documentation, such as a unified set of documents of 
API signatures for a platform that includes technologies expressed 
as GEM APIs. The file may also be used to produce "compilation 
stubs," which allow applications to be compiled and validated 
for such platforms.  Any such use as described in the prior two 
sentences may not modify or subset any file (or its class name 
or interface declaration) which begins with the name "org.dvb.*" 
(or its equivalent in any subsequent naming convention adopted 
by the DVB Project).  Redistribution of unified javadocs or of 
compiled stub files is permitted without charge.
<p>
Any work generated from this file, such as unified javadocs or 
compiled stub files, must be accompanied by this notice in its entirety.
<p>
This file corresponds to the API signatures of GEM 1.0.3: 
Digital Video Broadcasting (DVB); Globally Executable MHP (GEM), 
available from http://www.mhp.org/mhp_technology/gem/,
GEM 1.0.3 is published as TS 102 819 V1.4.1. 
In the event of a discrepancy between this file and such specification 
the latter takes precedence.
<p>
For further information about GEM and MHP, and the other licenses 
available in respect of the contents of these stubs, please refer 
to www.dvb.org. 
*/
package org.havi.ui.event;



/*

 * Copyright 2000-2003 by HAVi, Inc. Java is a trademark of Sun

 * Microsystems, Inc. All rights reserved.  

 */





import org.havi.ui.HActionable;



/**

   An {@link org.havi.ui.event.HActionEvent HActionEvent} event is used to

   interact with a component implementing the {@link

   org.havi.ui.HActionInputPreferred HActionInputPreferred} interface

   as follows:



   <p><ul>



   <li> An {@link org.havi.ui.event.HActionEvent HActionEvent} event may be sent

   from the HAVi system to the component to cause the component to

   become actioned.



   <li> An {@link org.havi.ui.event.HActionEvent HActionEvent} event is sent from

   the component to all registered {@link

   org.havi.ui.event.HActionListener HActionListeners} whenever the

   component is actioned.

   

   </ul><p>



   All interoperable HAVi components which expect to receive {@link

   org.havi.ui.event.HActionEvent HActionEvent} events must implement the

   {@link org.havi.ui.HActionInputPreferred

   HActionInputPreferred} interface.

   

 */

public class HActionEvent 

    extends java.awt.event.ActionEvent

{



    /**

     * Constructs an {@link org.havi.ui.event.HActionEvent

     * HActionEvent}.

     * 

     * @param source The {@link org.havi.ui.HActionInputPreferred 

     * HActionInputPreferred} component which has been actioned. 

     * @param id The event id of the {@link

     * org.havi.ui.event.HActionEvent HActionEvent} generated

     * by the {@link org.havi.ui.HActionInputPreferred HActionInputPreferred}

     * component. This is the value that will be returned by the

     * event object's <code>getID</code> method.  

     * @param command A String which is used as the action command

     * string for this event.

     */

    public HActionEvent(org.havi.ui.HActionInputPreferred source, int id, String command)

    {

	super(source, id, command);

    }



    /**

     * Retrieve the action command string associated with this event.

     *

     * @return the String which was used as the action command

     * string when this event was constructed.

     */

    public String getActionCommand() 

    {

        return("");

    }



    /**

     * Returns any modifiers held down during this action event.

     * <p>

     * Modifiers are not used for <code>HActionEvent</code>s with the

     * HAVi platform. Interoperable HAVi applications shall not use the

     * return value of this method.

     * 

     * @return an implementation-specific value. 

     */

    public int getModifiers() 

    {

        return(0);

    }







}




